/* 
(c) 2014 - Markus Backes - https://backes-markus.de/blog/
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
Dieses Programm ist Freie Software: Sie kï¿½nnen es unter den Bedingungen
der GNU General Public License, wie von der Free Software Foundation,
Version 3 der Lizenz oder (nach Ihrer Wahl) jeder neueren
verï¿½ffentlichten Version, weiterverbreiten und/oder modifizieren.
Dieses Programm wird in der Hoffnung, dass es nï¿½tzlich sein wird, aber
OHNE JEDE GEWï¿½HRLEISTUNG, bereitgestellt; sogar ohne die implizite
Gewï¿½hrleistung der MARKTFï¿½HIGKEIT oder EIGNUNG Fï¿½R EINEN BESTIMMTEN ZWECK.
Siehe die GNU General Public License fï¿½r weitere Details.

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>. 
*/

//Library includes
#include <FastLED.h>
#include <Time.h>
#include <avr/pgmspace.h>
#include "s_tools.h"
#include "pins.h"
#include "irmp.c"
#include "peda_dcf77.h"

// LED
#define MAX_LEDHELL 15
#define MIN_LEDHELL 1
unsigned char led_hell=MAX_LEDHELL/2;
prog_uchar pwmtable_16C[] PROGMEM = { 0,   2,   3,   4,   6,   8,  11,  16,  23,  32,  45, 64, 90, 128, 181, 255 };  
//prog_uchar pwmtable_11C[] PROGMEM = {0, 2, 4, 9, 11, 19, 32, 54, 91, 152, 255 };
//prog_uchar pwmtable_11C_rev[] PROGMEM = {255, 253, 251, 248, 244, 236, 223, 201, 164, 103,   1};


#include <Wire.h>
#include <DS1307new.h>
#define printIIC(args) Wire.write((uint8_t)args)
#define readIIC() Wire.read()

uint16_t TimeIsSet = 0xaa55;

#define DS1307_ID 0x68
#include "default_layout.h" 

volatile unsigned warte_ms;
volatile unsigned char count=0;
volatile unsigned char quitt_count=0;

bool timeInSync = false;

uint8_t strip[ARRAYLEN];
uint8_t stackptr = 0;

CRGB leds[ARRAYLEN];

#ifdef IR_REMOTE
IRrecv irrecv = IRrecv(IR_RECV_PIN);
decode_results irDecodeResults;
#endif

//const uint8_t BERLIN_MODE = 2;
const uint8_t RHEIN_RUHR_MODE = 1; //Define?
const uint8_t WESSI_MODE = 0;
//uint8_t selectedLanguageMode = BERLIN_MODE;
uint8_t selectedLanguageMode = WESSI_MODE;

unsigned char displayMode = DIY1;
unsigned char displayMode_merker = displayMode;

CRGB defaultColor;
CRGB sekundeColor;
#define MAX_COLOR 61

uint8_t colorIndex = 0;

int testHours = 0;
int testMinutes = 0;
int testSekunde = 0;

//multitasking helper

const long oneSecondDelay = 1000;
const long halfSecondDelay = 500;

unsigned long waitUntilRtc = 0;
unsigned long waitUntilParty = 0;
unsigned long waitUntilOff = 0;
unsigned long waitUntilFastTest = 0;
unsigned long waitUntilHeart = 0;
/*
unsigned long waitUntilDCF = 0;
*/
unsigned long waitUntilLDR = 0;

//forward declaration
void fastTest();
void clockLogic();
void doIRLogic();
void doLDRLogic();
void makeParty();
void off();
void showHeart();
void pushToStrip(int ledId);
void resetAndBlack();
void resetStrip();
void displayStripRandomColor();
void displayStrip();
void displayStrip(CRGB colorCode);
void timeToStrip(uint8_t hours,uint8_t minutes);
/*
void doDCFLogic();
*/
//char *prt_color(uint8_t colorIndex);

void sec_sync(void)
{ RTC.getTime();
  uint8_t altsekunde=RTC.second;
  if(count>95)
  { do
    { RTC.getTime();
    }while(altsekunde==RTC.second);
    count=0;
  } // if(count>90)      
} // void sec_sync(void)


#define READS 4

uint16_t lese_analog(uint8_t _port)
{ int8_t i;
  uint16_t _adc=0;
  for(i=0; i<(1<<READS); i++)
    _adc += analogRead(_port);    // read the input pin
  _adc >>= READS;
  return _adc;
}

int jj=0, mo=0, ta=0, hh=0, mm=0, ss=0, jjjj=0;
char c_time_str[9];        // "12:13:14/0"
char c_date_str[12];       // "2014/10/11/0"
char c_date_long_str[15];  // "Di 10.Okt 2014/0"

#define LEDCLR FastLED.clear()
static char akthell_str[5];
static uint8_t akthell_int;

uint8_t rt=128;
uint8_t gr=128;
uint8_t bl=128;
//CRGB _auto_ldr=CRGB(rt,gr,bl);
//leds[AUTOLDR]=CRGB(rt,gr,bl);

IRMP_DATA irmp_data;
volatile uint8_t _flash = 0;
volatile uint8_t _heart = 0;


char serial_in_buff[40]={0};
unsigned char chr_cnt=0;
char serial_in_command[40]={0};
extern uint8_t akt_dcf77_pulse;

void loop(void) 
{ RTC.getTime();

  doIRLogic();
  doLDRLogic();
#ifdef MY_DCF77_POW
/*
//  if( dcf77_startzeit == 0 && ((RTC.time2000/3600)%24) == DCF77_sync_HH && ((RTC.time2000/60)%60) == DCF77_sync_MM )
  { sprintf(r_str, "%04d/%02d/%02d_%02d:%02d:%02d", RTC.year, RTC.month, RTC.day, RTC.hour, RTC.minute, RTC.second); 
    dcf77_startzeit=RTC.time2000;
    Serial.print(r_str); Serial.print(F(", Startsekunde RTC = ")); Serial.println(dcf77_startzeit);
    dcf77error_try=DCF_MAX_ERROR_TRY;
    dcf77_OK=0;
    dcf_off_time=0;
    dcf77error_cnt=0;
    my_cnt_rdy=0;
    my_cnt_low=0;
    my_dcf77_pulse=0;
    my_dcf77_period=0;
    merke_my_dcf77_period=0;
    dcf77error = 0;
    rtc_is_set=0;
    MY_DCF77_POW_DDR |= (1<<MY_DCF77_POW);
    MY_DCF77_POW_ON;
    MY_DCF77_IN_DDR&=~(1<<MY_DCF77_IN);
    MY_DCF77_IN_PORT|=(1<<MY_DCF77_IN);
  } // if(((RTC.time2000/60) % 60 ) == 0)
*/
  if( dcf77_startzeit )
    dcf_auswertung();
  else
    sec_sync();
#endif
/*
  if(akt_dcf77_pulse)
  { Serial.print(akt_dcf77_pulse); Serial.print(F(", c= ")); Serial.println(newtime.sekund);
    akt_dcf77_pulse=0;
  }
*/
  if(led_test_flags&(1<<LED_ON))
  { if(led_test_flags&(1<<LED_NEXT))
    { if( ((RTC.second %30) == 14) && !_flash )
      { displayMode_merker = displayMode;
        displayMode = DIY2;
        _flash = 1;
        testHours = -1; testMinutes = -1;
      } // if( ( (RTC.minute % 5) == 4 ) && ( (RTC.second %10) == 1 ) && !_flash )      
      if( ((RTC.second %30) == 19) && _flash )
      { displayMode = displayMode_merker;
        _flash = 0;
        testHours = -1; testMinutes = -1;
      } // if( ( (RTC.minute % 5) == 4 ) && ( (RTC.second %10) == 5 ) && _flash )      
      
      if( ((RTC.second %30) == 0) && !_heart )
      { displayMode_merker = displayMode;
        displayMode = DIY3;
        _heart = 1;
        testHours = -1; testMinutes = -1;
      } // if( ( (RTC.minute % 5) == 4 ) && ( (RTC.second %10) == 1 ) && !_flash )      
      if( ((RTC.second %30) == 6) && _heart )
      { displayMode = displayMode_merker;
        _heart = 0;
        testHours = -1; testMinutes = -1;
      } // if( ( (RTC.minute % 5) == 4 ) && ( (RTC.second %10) == 5 ) && _flash )      
  
    } // if(led_test_flags&(1<<LED_NEXT))
  } // if(led_test_flags&(1<<LED_ON)) 

  switch(displayMode) 
  { 
#ifdef BIG_FB    
    case POWER:
      off();
      break;
#else
    case OFF:
        led_test_flags&=~(1<<LED_ON));
        off();
      break;
    case ON:
        led_test_flags|=(1<<LED_ON)));
        off();
      break;
#endif
    case DIY1:
      clockLogic();
      break;
    case DIY2:
      makeParty();
      break;
    case DIY3:
      showHeart();
      break;
    case DIY4:
      fastTest();
      break;
    default:
      clockLogic();
      break;
  }
// --------------- serial in ---------------
    if (Serial.available() > 0) 
    { char incomingByte = (char)Serial.read();
      if(incomingByte == 13)  // Wenn das Enter ankommt
      { strcpy(serial_in_command, serial_in_buff);
        chr_cnt = 0;
        strcpy(serial_in_buff,"");
        //memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
      }
      else // Falls kein Enter kommt muss der Text gespeichert werden in dem inText Array
      { if(isprint(incomingByte))
          serial_in_buff[chr_cnt++] = incomingByte;
      }
    } // if (Serial.available() > 0) 
  
    if(strlen(serial_in_command))
    { Serial.println(); Serial.print(serial_in_command);  Serial.println(F(" -> erkannt")); *serial_in_buff=0; chr_cnt=0; 
    }
          
    if( strstr(serial_in_command, "help") || ( strstr(serial_in_command, "?") && strlen(serial_in_command)==1 ) )
    { // help screen
      Serial.println(F("\ncommands: \n"));
      Serial.println(F("setdate2015/01/15"));
      Serial.println(F("getdate"));
      Serial.println(F("settime17:22:30"));
      Serial.println(F("gettime"));
      Serial.println(F("ledpower"));
      Serial.println(F("ledpower?"));
      Serial.println(F("ledhell?"));
      Serial.println(F("dcf77"));
      Serial.println(F("dcf77?"));
      Serial.println(F("reset"));
      Serial.println();
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    }
    if( strstr(serial_in_command, "setdate") )
    { // "setdate2014/10/05"  setdate2015/01/15
      if(strlen(serial_in_command)>=17) 
      { if( (i2c_test_flags&(1<<I2C_RTC_1307)) | (i2c_test_flags&(1<<I2C_RTC_3231)) )
        { uint16_t jjjj=atoi(strncpy(serial_in_buff, &serial_in_command[7], 4));
          if( jjjj >= atoi(strncpy(serial_in_buff, c_str, 4)) )
          { uint8_t mo = atoi(strncpy(serial_in_buff, &serial_in_command[12], 2)); 
            if(mo && mo<13) 
            { uint8_t ta=atoi(rights(serial_in_command, 2));
              if(!(ta>0 && ta<= Monatstage(jjjj, mo))) 
                ta=0;
              if(ta)  
              { RTC.getTime();
DEBUG_PRINT(F("nach ta \"")); DEBUG_PRINT(ta); DEBUG_PRINT(F("\", "));
                sprintf(r_str, "%04d/%02d/%02d_%02d:%02d:%02d", jjjj, mo, ta, RTC.hour, RTC.minute, RTC.second); 
                if(strncmp(r_str, (char *)&c_str[0], 8)>0) DEBUG_PRINTLN(F("compile > inputdatetime -> nicht gestellt"));
                if(strncmp(r_str, c_str, 6)<0) 
                { DEBUG_PRINTLN(F("compile < inputdatetime "));
                } // if(strncmp(r_str, c_str, 6)<0) 
                if(!strncmp(c_str, r_str, 6)) 
                { DEBUG_PRINTLN(F("strncmp(c_str, r_str, 6)")); 
                  DEBUG_PRINT(F("c ")); DEBUG_PRINTLN(c_str);
                  DEBUG_PRINT(F("e ")); DEBUG_PRINTLN(r_str);
                  DEBUG_PRINTLN(F("compile == inputdatetime "));
                }
              } // if(ta)        
              else
              { DEBUG_PRINTLN(F("ERROR TA=0 RTC nicht gestellt !"));
                memset(&serial_in_command[0], 0, sizeof(serial_in_command));
                memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
              }
            } // if(mo)
            else
            { DEBUG_PRINTLN(F(" -> ERROR !MO oder (JahrMonat < compile), RTC nicht gestellt !"));
              memset(&serial_in_command[0], 0, sizeof(serial_in_command));
              memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
            }
          } // if( jjjj >= atoi(lefts(c_str, 4)) )
          else
          { DEBUG_PRINTLN(F(" -> ERROR (jjjj < compile), RTC nicht gestellt !"));
            memset(&serial_in_command[0], 0, sizeof(serial_in_command));
            memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
          }
        } // if(i2c_test_flags&(1<<RTC_CHIP))
      } // if(strlen(serial_in_command)>=17)
      else
      { Serial.print(F("\"")); Serial.print(serial_in_command); Serial.println(F("\" -> zu kurz, min. 17 Zeichen \"setdate2014/10/05\"")); 
        memset(&serial_in_command[0], 0, sizeof(serial_in_command));
        memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
      }
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if(strstr(serial_in_buff, "setdate"))
  
    if( strstr(serial_in_command, "getdate") )
    { // "getdate"
      //sprintf(r_str, "%04d%02d%02d%02d%02d%02d", RTC.year, RTC.month, RTC.day, RTC.hour, RTC.minute, RTC.second);
      sprintf((char *)serial_in_buff,"%s %02d.%s %04d", strWochentagname_kurz( wochentag_im_jahr(RTC.year, tagesnummer( RTC.year, RTC.month, RTC.day )) ), RTC.day, lefts(strMonatsname(RTC.month), 3), RTC.year);
      Serial.println(serial_in_buff);
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( strstr(serial_in_command, "getdate") )

    if( strstr(serial_in_command, "settime") )
    { // "settime17:22:30" 
      if(strlen(serial_in_command)>=15) 
      { if( (i2c_test_flags&(1<<I2C_RTC_1307)) | (i2c_test_flags&(1<<I2C_RTC_3231)) )
        { uint8_t hh=atoi(strncpy(serial_in_buff, &serial_in_command[7], 2));
          if( 0 <= hh && hh < 24)
          { uint8_t mm = atoi(strncpy(serial_in_buff, &serial_in_command[10], 2)); 
            if( 0 <= mm && mm < 60)
            { uint8_t ss=atoi(rights(serial_in_command, 2));
              if( 0 <= ss && ss < 60)
              { RTC.fillByHMS( hh, mm, ss );
                sprintf(r_str, "%02d:%02d:%02d", RTC.hour, RTC.minute, RTC.second); 
                _i2c_busy=1; RTC.setTime(); _i2c_busy=0;
                (i2c_test_flags&(1<<I2C_RTC_3231)) ? Serial.println(F(" DS3231 RTC ist gestellt")) : Serial.println(F(" DS1307 RTC ist gestellt"));
                _i2c_busy=1; RTC.getTime(); _i2c_busy=0;
                RTC.getTime();
                sprintf(r_str, "%04d/%02d/%02d_%02d:%02d:%02d", RTC.year, RTC.month, RTC.day, RTC.hour, RTC.minute, RTC.second);
                Serial.println(r_str); Serial.println();
              } // if(ss)        
              else
              { DEBUG_PRINTLN(F("ERROR ss Fehler RTC nicht gestellt !"));
              }
            } // if(mm)
            else
            { DEBUG_PRINTLN(F("ERROR mm Fehler RTC nicht gestellt !"));
            }
          } // if(hh)
          else
          { DEBUG_PRINTLN(F("ERROR hh Fehler RTC nicht gestellt !"));
          }
        } // if(i2c_test_flags&(1<<RTC_CHIP))
      } // if(strlen(serial_in_command)>=15)
      else
      { Serial.print(F("\"")); Serial.print(serial_in_command); 
        Serial.print(F("\" -> zu kurz: ")); Serial.print(strlen(serial_in_command)); 
        Serial.println(F(", min. 15 Zeichen \"settime17:22:30\"")); 
      }
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if(strstr(serial_in_buff, "settime"))

    if( strstr(serial_in_command, "gettime") )
    { // "gettime"
      sprintf((char *)serial_in_buff,"%02d:%02d:%02d", RTC.hour, RTC.minute, RTC.second);
      Serial.print(serial_in_buff); Serial.println(F(" Uhr"));
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( strstr(serial_in_command, "gettime") )

    if( !strcmp(serial_in_command, "ledpower") )
    { // "ledpower"
      off();
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "ledpower") )
  
    if( !strcmp(serial_in_command, "ledhell?") )
    { // "ledhell?"
      Serial.print(F("ledhell= ")); Serial.println(led_hell);
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "ledpower?") )

    if( !strcmp(serial_in_command, "ledpower?") )
    { // "ledpower?"
      if((led_test_flags&(1<<LED_ON)))
        Serial.println(F("LED ist ON"));
      else
        Serial.println(F("LED ist OFF"));
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "ledpower?") )
/*
#ifdef MY_DCF77_POW
    if( !strcmp(serial_in_command, "dcf77") )
    { // "dcf77"
      if( MY_DCF77_POW_PORT & (1<<MY_DCF77_POW))
      { MY_DCF77_POW_OFF;
        Serial.println(F("dcf77 set OFF"));
      }
      else
      { MY_DCF77_POW_ON;
        Serial.println(F("dcf77 set ON"));
      }
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "dcf77") )
  
    if( !strcmp(serial_in_command, "dcf77?") )
    { // "dcf77"
      if( MY_DCF77_POW_DDR & (1<<MY_DCF77_POW))      
      { Serial.println(F("dcf77 pow DDR ist AUSGANG"));
        if( MY_DCF77_POW_PORT & (1<<MY_DCF77_POW))
          Serial.println(F("dcf77 pow ist ON"));
        else
          Serial.println(F("dcf77 pow ist OFF"));
      }
      else
        Serial.println(F("dcf77 pow DDR ist EINGANG"));
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "dcf77?") )
#endif  
*/
    if( !strcmp(serial_in_command, "reset") )
    { // "reset"
      {asm("ldi r30,0"); asm("ldi r31,0"); asm("ijmp");}
      memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    } // if( !strcmp(serial_in_command, "reset") )
  
    if(strlen(serial_in_command))
    { memset(&serial_in_command[0], 0, sizeof(serial_in_command));
      memset(&serial_in_buff[0], 0, sizeof(serial_in_buff));
    }
// --------------- serial in ---------------

} // void loop(void) 


void doLDRLogic() 
{ static uint8_t count_led_hell=0, sum_led_hell=0;
#ifdef LICHTSENSOR
  if(count>50 && count <60)
  { uint16_t _lichtsensor=lese_analog(LICHTSENSOR);
    itoa ( _lichtsensor, akthell_str, 10 );
    if(_lichtsensor<110)
      _lichtsensor= map( _lichtsensor, 0, 109, 1, 6);    
    if( 110 <= _lichtsensor && _lichtsensor <= 700 )
      _lichtsensor= map( _lichtsensor, 110, 700, 6, 8);    
    if( 701 <= _lichtsensor && _lichtsensor <= 1023 )
      _lichtsensor= map( _lichtsensor, 701, 1023, 8, 15);    
/*
LDR	hell
958	10
944	10
928	9
887	9
859	9
746	8
286	7
109	6
105	6
99	6
95	5
94	4
14	3
*/
//    Serial.print(F("LDR vor  map ")); Serial.println(_lichtsensor);
      //prog_uchar pwmtable_16C[] PROGMEM = {  0,   2,   3,   4,   6,   8,  11,  16,  23,  32,  45, 64, 90, 128, 181, 255};  
//    _lichtsensor= map( (int)pow((float)_lichtsensor, (float)((float)1/(float)1.5)), 0, 101, 4, 15);
//_lichtsensor= map( (int)pow((float)_lichtsensor, (float)((float)1/(float)2)), 0, 31, 4, 15);
//    _lichtsensor= map( (int)pow((float)_lichtsensor, (float)((float)1/(float)3)), 0, 10, 4, 15);
//    _lichtsensor= map( (int)pow((float)_lichtsensor, (float)((float)1/(float)4)), 0, 5, 4, 15);
//    _lichtsensor= map( (int)pow((float)_lichtsensor, (float)((float)1/(float)5)), 0, 3, 4, 15);
//    Serial.print(F("LDR nach map ")); Serial.println(_lichtsensor);
//    Serial.println();
    if(led_test_flags&(1<<AUTO_LDR))
    { leds[AUTOLDR] = AUTOLDR_COL;
      led_hell=_lichtsensor;
      sum_led_hell+=led_hell;
      count_led_hell++;
      if( led_test_flags&(1<<LED_ON) )
      { if(count_led_hell==10)
        { sum_led_hell/=count_led_hell;
          led_hell=sum_led_hell;
          sum_led_hell=0;
          count_led_hell=0;
          FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
          FastLED.show();
        } // if(count_led_hell==10)
      } // if( led_test_flags&(1<<LED_ON) )
    } // if(led_test_flags&(1<<AUTO_LDR))
  } // if(count>50 && count <60)
#else
    #include "NO_LICHTSENSOR.H"
#endif
} // void doLDRLogic() 

void doIRLogic() 
{
#ifdef F_INTERRUPTS
  if (irmp_get_data (&irmp_data))
  { // ir signal decoded, do something here...
//    switch(irmp_data.protocol)
//    { // irmp_data.protocol is the protocol, see irmp.h  // irmp_data.address is the address/manufacturer code of ir sender 
      // irmp_data.command is the command code           // irmp_protocol_names[irmp_data.protocol] is the protocol name (if enabled, see irmpconfig.h)
#ifdef IRMP_SUPPORT_NEC_PROTOCOL
      if(irmp_data.protocol==IRMP_NEC_PROTOCOL )
      {
//      case IRMP_NEC_PROTOCOL: 
//        Serial.print(F("IR: ")); Serial.print(F("NEC")); Serial.print(F(", Address: ")); Serial.print(irmp_data.address); Serial.print(F(", Command: ")); Serial.println(irmp_data.command); 
        if (irmp_data.flags & IRMP_FLAG_REPETITION)
        { if(irmp_data.address==RGB_LED_FB)
          { switch(irmp_data.command) 
            { 
/*
              case ROT_UP:
                if(rt<245) 
                { rt+=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
              case GRUEN_UP:
                if(gr<245) 
                { gr+=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
              case BLAU_UP:
                if(bl<245) 
                { bl+=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
              case ROT_DOWN:
                if(rt>=10) 
                { rt-=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
              case GRUEN_DOWN:
                if(gr>=10) 
                { gr-=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
              case BLAU_DOWN:
                if(bl>=10) 
                { bl-=10;
                  _auto_ldr=CRGB(rt,gr,bl);
                  leds[AUTOLDR] = _auto_ldr;
                }
                break;
*/
            }
          } // if(irmp_data.address==RGB_LED_FB)
        } // if (irmp_data.flags & IRMP_FLAG_REPETITION)
        if (!(irmp_data.flags & IRMP_FLAG_REPETITION))
        { 
#ifdef BIG_FB
          if(irmp_data.address==RGB_LED_FB)
          { if( led_test_flags&(1<<LED_ON) )  
            { quitt_count=25; leds[IRQUITT] = IRQUITT_COL; 
              FastLED.show();
            }
            switch(irmp_data.command) 
            { case POWER:
//                displayMode = POWER;
                off();
		break;
              case AUTO:
                led_test_flags|=(1<<AUTO_LDR);
                doLDRLogic();
                Serial.print(F("LDR ")); Serial.print(akthell_str); Serial.print(F(", LED hell AUTO= ")); Serial.println(led_hell); //Serial.println(F("%")); 
		break;
	      case HELL_UP:
                if(led_hell<MAX_LEDHELL)
                { led_test_flags&=~(1<<AUTO_LDR);
                  leds[AUTOLDR] = CRGB::Black; 
                  led_hell++;
                  if( led_test_flags&(1<<LED_ON) )  
                  { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
                    FastLED.show();
                  }
                  Serial.print(F("LDR ")); Serial.print(akthell_str); Serial.print(F(", LED hell up ")); Serial.println(led_hell);
                } // if(irmp_data.command==HELL_UP && led_hell<MAX_LEDHELL)
		break;
              case HELL_DOWN:
                if(led_hell>MIN_LEDHELL)
                { led_test_flags&=~(1<<AUTO_LDR);
                  leds[AUTOLDR] = CRGB::Black; 
                  led_hell--;
                  if( led_test_flags&(1<<LED_ON) )  
                  { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
                    FastLED.show();
                  }
                  Serial.print(F("LDR ")); Serial.print(akthell_str); Serial.print(F(", LED hell down ")); Serial.println(led_hell);
                } // if(irmp_data.command==HELL_DOWN && led_hell>MIN_LEDHELL)                
                break;
              case DIY1:
                led_test_flags|=(1<<AUTO_COLOR);
                displayMode = DIY1;
                displayMode_merker = displayMode;
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
              case DIY2:
                //displayMode_merker = displayMode;
		displayMode = DIY2;
		break;
	      case DIY3:
                //displayMode_merker = displayMode;
		displayMode = DIY3;
		break;
	      case DIY4:
                //displayMode_merker = displayMode;
		displayMode = DIY4;
		break;
/*
	      case DIY5:
                if( led_test_flags&(1<<LED_DCF77) )
                { led_test_flags&=~(1<<LED_DCF77);
                  leds[DCFLED]=CRGB::Black;
                }
                else
                { led_test_flags|=(1<<LED_DCF77);
                  leds[DCFLED]=DCFLED_COL;
                }
                if( led_test_flags&(1<<LED_ON) )  
                { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
                  FastLED.show();
                }
*/
		break;
	      case DIY6:
                if( led_test_flags&(1<<LED_WLAN) )
                { led_test_flags&=~(1<<LED_WLAN);
                  leds[WLAN]=CRGB::Black;
                }
                else
                { led_test_flags|=(1<<LED_WLAN);
                  leds[WLAN]=WLAN_COL;
                }
                if( led_test_flags&(1<<LED_ON) )  
                { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
                  FastLED.show();
                }
		break;
/*
#ifdef MY_DCF77_POW
	      case JUMP3:
                if( (MY_DCF77_POW_DDR & (1<<MY_DCF77_POW)) && (MY_DCF77_POW_PORT & (1<<MY_DCF77_POW)) )
                { DEBUG_PRINTLN("DCF77 power is ON");
                  if( !(MY_DCF77_IN_DDR & (1<<MY_DCF77_IN)) )
                  { MY_DCF77_IN_DDR |= (1<<MY_DCF77_IN);
                    DEBUG_PRINTLN("DCF77in is OUTPUT");
                    MY_DCF77_IN_PORT &= ~(1<<MY_DCF77_IN);                    
                    DEBUG_PRINTLN("DCF77in is LOW\n");
                  }
                  else
                  { MY_DCF77_IN_DDR &= ~(1<<MY_DCF77_IN);
                    DEBUG_PRINTLN("DCF77in is INPUT");
                    MY_DCF77_IN_PORT|=(1<<MY_DCF77_IN);
                    DEBUG_PRINTLN("DCF77in pullup is set\n");
                  }
                }
                else
                  DEBUG_PRINTLN("DCF77 power is OFF\n");                
		break;

	      case JUMP7:
                dcf_off_time=255;
                if( (MY_DCF77_POW_DDR & (1<<MY_DCF77_POW)) )
                { DEBUG_PRINTLN("DCF power DDR is OUTPUT");
                  if(MY_DCF77_POW_PORT & (1<<MY_DCF77_POW))
                  { DEBUG_PRINTLN("DCF power is ON, set2low");
                    MY_DCF77_POW_OFF;
                    DEBUG_PRINTLN("DCF power is OFF\n");
                  }
                  else
                  { DEBUG_PRINTLN("DCF power is OFF, set2high");
                    MY_DCF77_POW_ON;
                    DEBUG_PRINTLN("DCF power is ON\n");
                  }
                }
		break;

	      case FADE7:
                if( (MY_DCF77_POW_DDR & (1<<MY_DCF77_POW)) && (MY_DCF77_POW_PORT & (1<<MY_DCF77_POW)) )
                { DEBUG_PRINTLN("DCF77 power is ON");
                  if( !(MY_DCF77_IN_DDR & (1<<MY_DCF77_IN)) )
                    DEBUG_PRINTLN("DCF77in is INPUT\n");
                  else
                    DEBUG_PRINTLN("DCF77in is OUTPUT\n");
                }
                else
                  DEBUG_PRINTLN("DCF77 power is OFF\n");                
		break;

#endif
*/
	      case FADE3:
                Serial.print(F("LDR ")); Serial.print(akthell_str); Serial.print(F(", LED hell ")); Serial.println(led_hell);
		break;

	      case FLASH:
                if(led_test_flags&(1<<LED_ON))
                  FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
		displayMode = FLASH;
		break;

	      case QUICK:
		defaultColor = nextColor();
		sekundeColor = defaultColor;
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
                break;
	      case SLOW:
		defaultColor = prevColor();
		sekundeColor = defaultColor;
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;

	      case ROT:
                defaultColor = CRGB::Red;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case GRUEN:
                defaultColor = CRGB::Green;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case BLAU:
                defaultColor = CRGB::Blue;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case WEISS:
                defaultColor = CRGB::White;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case GELB:
                defaultColor = CRGB::Yellow;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case CYAN:
                defaultColor = CRGB::Cyan;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case PURPUR:
                defaultColor = CRGB::Purple;    
                sekundeColor = defaultColor;
                led_test_flags&=~(1<<AUTO_COLOR);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case NEXT:
                led_test_flags^=(1<<LED_NEXT);
		displayStrip();
		//to force display update
		testMinutes = -1; testHours = -1;
		break;

/*
	      case ROT_UP:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case GRUEN_UP:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case BLAU_UP:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;

	      case ROT_DOWN:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case GRUEN_DOWN:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
	      case BLAU_DOWN:
                led_test_flags&=~(1<<AUTO_COLOR);
		//to force display update
		testMinutes = -1; testHours = -1;
		break;
*/
	      default:
		Serial.print(F("IR: ")); Serial.print(F("NEC")); Serial.print(F(", Address: ")); Serial.print(irmp_data.address); Serial.print(F(", Command: ")); Serial.println(irmp_data.command); 
		break;
            }
	    //while(irmp_get_data(&irmp_data));
          } // if(irmp_data.address==RGB_LED_FB)
//        {  if(irmp_data.address==RGB_LED_FB && irmp_data.command==27) { prg++; if(prg>9){alt_prg=prg; prg=1;} }
        } // if (!(irmp_data.flags & IRMP_FLAG_REPETITION))
#endif
//        while(irmp_get_data (&irmp_data));
//        break;
#else
  #include "NO IRMP_SUPPORT_NEC_PROTOCOL"
#endif //#ifdef IRMP_SUPPORT_NEC_PROTOCOL
//    } //switch(irmp_data.protocol)
    } //if(irmp_data.protocol==IRMP_NEC_PROTOCOL )
  } //if (irmp_get_data (&irmp_data))
#else
  #include "NO F_INTERRUPTS"
#endif //#ifdef F_INTERRUPTS
} //void doIRLogic() 


//---------------------
//DISPLAY MODES
//---------------------
void clockLogic() 
{ if(i2c_test_flags&( (1<<RTC_3231) | (1<<RTC_1307) ) )
  { if(count>94)
    { do
      { RTC.getTime();
      }while(testSekunde==RTC.second);
      count=0;
      testSekunde=RTC.second;
    } // if(count>94)
    if(testMinutes != RTC.minute || testHours != RTC.hour) 
    { testMinutes = RTC.minute;  testHours = RTC.hour;
      if(led_test_flags&(1<<LED_ON))
      { resetAndBlack(); timeToStrip(testHours, testMinutes);
        displayStrip(defaultColor); sekundeColor=defaultColor;
        if(led_test_flags&(1<<AUTO_COLOR))
        { defaultColor = nextColor();
        }
      }
    } //if(testMinutes != RTC.minute || testHours != RTC.hour) 
  } //if(i2c_test_flags&( (1<<RTC_3231) | (1<<RTC_1307) ) )
  else
    Serial.println(F("no RTC, not included ")); 
} //void clockLogic() 


void off() 
{ 
#ifdef BIG_FB    
  if(led_test_flags&(1<<LED_ON))
  { led_test_flags&=~(1<<LED_ON);
    FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[0]));
    Serial.println(F("LED set OFF"));
  }
  else
  { led_test_flags|=(1<<LED_ON);
    FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
    Serial.println(F("LED set ON"));
  }
#else
  if(led_test_flags&(1<<LED_ON))
      FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
  else
    FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[0]));
#endif
  FastLED.show();
} //void off() 


void makeParty() 
{ if(millis() >= waitUntilParty) 
  { //DEBUG_PRINT("YEAH party party");
    waitUntilParty = millis();
    resetAndBlack();
    for(int i = 0; i<(ARRAYLEN-LEDOFFSET); i++) 
      leds[i] = CHSV(random(0, 255), 255, 255);
    FastLED.show();
    waitUntilParty += halfSecondDelay;
  } //if(millis() >= waitUntilParty) 
} //void makeParty() 


void showHeart() 
{ leds[AUTOLDR] = CRGB::Black; 
  if(millis() >= waitUntilHeart) 
  { //DEBUG_PRINT("showing heart");
    waitUntilHeart = millis();
    resetAndBlack();
    pushToStrip(L29); pushToStrip(L30); pushToStrip(L70); pushToStrip(L89);
    pushToStrip(L11); pushToStrip(L48); pushToStrip(L68); pushToStrip(L91);
    pushToStrip(L7); pushToStrip(L52); pushToStrip(L107);
    pushToStrip(L6); pushToStrip(L106);
    pushToStrip(L5); pushToStrip(L105);
    pushToStrip(L15); pushToStrip(L95);
    pushToStrip(L23); pushToStrip(L83);
    pushToStrip(L37); pushToStrip(L77);
    pushToStrip(L41); pushToStrip(L61);
    pushToStrip(L59);
    displayStrip(CRGB::Red);
    waitUntilHeart += oneSecondDelay;
  } //if(millis() >= waitUntilHeart) 
  if(led_test_flags&(1<<AUTO_LDR))
    leds[AUTOLDR] = AUTOLDR_COL; 
} //void showHeart() 


void fastTest() 
{ if(millis() >= waitUntilFastTest) 
  { DEBUG_PRINT("fast Test");
    waitUntilFastTest = millis();
    if(testMinutes >= 60) 
    { testMinutes = 0;
      testHours++;
    } //if(testMinutes >= 60) 
    if(testHours >= 24) 
      testHours = 0;
	
    //Array leeren
    resetAndBlack();
    timeToStrip(testHours, testMinutes);
    displayStripRandomColor();
    testMinutes++;
    waitUntilFastTest += oneSecondDelay;
  } //if(millis() >= waitUntilFastTest) 
  if(led_test_flags&(1<<AUTO_LDR))
    leds[AUTOLDR] = AUTOLDR_COL; 
} //void fastTest() 
//---------------------------------------

CRGB prevColor() 
{ if(colorIndex > 0) 
    colorIndex--;
  return getColorForIndex();
} //CRGB prevColor() 

CRGB nextColor() 
{ if(colorIndex < MAX_COLOR) 
    colorIndex++;
  else
    colorIndex=0;
  return getColorForIndex();
} //CRGB nextColor() 

CRGB getColorForIndex() 
{ switch(colorIndex) 
  { case 0:
      return CRGB::AliceBlue;
    case 1:
      return CRGB::Amethyst;
    case 2:
      return CRGB::AntiqueWhite;
    case 3:
      return CRGB::Aquamarine;
    case 4:
      return CRGB::Azure;
    case 5:
      return CRGB::Beige;
    case 6:
      return CRGB::Bisque;
    case 7:
      return CRGB::BlanchedAlmond;
    case 8:
      return CRGB::Blue;
    case 9:
      return CRGB::BlueViolet;

    case 10:
      return CRGB::Brown;
    case 11:
      return CRGB::BurlyWood;
    case 12:
      return CRGB::CadetBlue;
    case 13:
      return CRGB::Chartreuse;
    case 14:
      return CRGB::Chocolate;
    case 15:
      return CRGB::Coral;
    case 16:
      return CRGB::CornflowerBlue;
    case 17:
      return CRGB::Cornsilk;
    case 18:
      return CRGB::Crimson;
    case 19:
      return CRGB::Cyan;

    case 20:
      return CRGB::DeepPink;
    case 21:
      return CRGB::DeepSkyBlue;
    case 22:
      return CRGB::DimGray;
    case 23:
      return CRGB::DodgerBlue;
    case 24:
      return CRGB::FireBrick;
    case 25:
      return CRGB::FloralWhite;
    case 26:
      return CRGB::ForestGreen;
    case 27:
      return CRGB::Fuchsia;
    case 28:
      return CRGB::Gainsboro;
    case 29:
      return CRGB::GhostWhite;

    case 30:
      return CRGB::Gold;
    case 31:
      return CRGB::Goldenrod;
    case 32:
      return CRGB::Gray;
    case 33:
      return CRGB::Green;
    case 34:
      return CRGB::GreenYellow;
    case 35:
      return CRGB::Honeydew;
    case 36:
      return CRGB::HotPink;
    case 37:
      return CRGB::IndianRed;
    case 38:
      return CRGB::Indigo;
    case 39:
      return CRGB::Ivory;

    case 40:
      return CRGB::Khaki;
    case 41:
      return CRGB::Lavender;
    case 42:
      return CRGB::LavenderBlush;
    case 43:
      return CRGB::LawnGreen;
    case 44:
      return CRGB::LemonChiffon;
    case 45:
      return CRGB::LightBlue;
    case 46:
      return CRGB::LightCoral;
    case 47:
      return CRGB::LightCyan;
    case 48:
      return CRGB::LightGoldenrodYellow;
    case 49:
      return CRGB::LightGreen;

    case 50:
      return CRGB::LightGrey;
    case 51:
      return CRGB::LightPink;
    case 52:
      return CRGB::LightSalmon;
    case 53:
      return CRGB::LightSeaGreen;
    case 54:
      return CRGB::LightSkyBlue;
    case 55:
      return CRGB::LightSlateGray;
    case 56:
      return CRGB::LightSteelBlue;
    case 57:
      return CRGB::LightYellow;
    case 58:
      return CRGB::Lime;
    case 59:
      return CRGB::LimeGreen;

    case 60:
      return CRGB::Linen;
    case 61:
      return CRGB::Magenta;
//#define MAX_COLOR 61
/*
CRGB::Maroon	KEYWORD2
CRGB::MediumAquamarine	KEYWORD2
CRGB::MediumBlue	KEYWORD2
CRGB::MediumOrchid	KEYWORD2
CRGB::MediumPurple	KEYWORD2
CRGB::MediumSeaGreen	KEYWORD2
CRGB::MediumSlateBlue	KEYWORD2
CRGB::MediumSpringGreen	KEYWORD2
CRGB::MediumTurquoise	KEYWORD2
CRGB::MediumVioletRed	KEYWORD2
CRGB::MidnightBlue	KEYWORD2
CRGB::MintCream	KEYWORD2
CRGB::MistyRose	KEYWORD2
CRGB::Moccasin	KEYWORD2
CRGB::NavajoWhite	KEYWORD2
CRGB::Navy	KEYWORD2
CRGB::OldLace	KEYWORD2
CRGB::Olive	KEYWORD2
CRGB::OliveDrab	KEYWORD2
CRGB::Orange	KEYWORD2
CRGB::OrangeRed	KEYWORD2
CRGB::Orchid	KEYWORD2
CRGB::PaleGoldenrod	KEYWORD2
CRGB::PaleGreen	KEYWORD2
CRGB::PaleTurquoise	KEYWORD2
CRGB::PaleVioletRed	KEYWORD2
CRGB::PapayaWhip	KEYWORD2
CRGB::PeachPuff	KEYWORD2
CRGB::Peru	KEYWORD2
CRGB::Pink	KEYWORD2
CRGB::Plaid	KEYWORD2
CRGB::Plum	KEYWORD2
CRGB::PowderBlue	KEYWORD2
CRGB::Purple	KEYWORD2
CRGB::Red	KEYWORD2
CRGB::RosyBrown	KEYWORD2
CRGB::RoyalBlue	KEYWORD2
CRGB::SaddleBrown	KEYWORD2
CRGB::Salmon	KEYWORD2
CRGB::SandyBrown	KEYWORD2
CRGB::SeaGreen	KEYWORD2
CRGB::Seashell	KEYWORD2
CRGB::Sienna	KEYWORD2
CRGB::Silver	KEYWORD2
CRGB::SkyBlue	KEYWORD2
CRGB::SlateBlue	KEYWORD2
CRGB::SlateGray	KEYWORD2
CRGB::Snow	KEYWORD2
CRGB::SpringGreen	KEYWORD2
CRGB::SteelBlue	KEYWORD2
CRGB::Tan	KEYWORD2
CRGB::Teal	KEYWORD2
CRGB::Thistle	KEYWORD2
CRGB::Tomato	KEYWORD2
CRGB::Turquoise	KEYWORD2
CRGB::Violet	KEYWORD2
CRGB::Wheat	KEYWORD2
CRGB::White	KEYWORD2
CRGB::WhiteSmoke	KEYWORD2
CRGB::Yellow	KEYWORD2
CRGB::YellowGreen	KEYWORD2
*/






    default:
      colorIndex = 0;
      return CRGB::White;
  } //switch(colorIndex) 
} //CRGB getColorForIndex() 

void pushToStrip(int ledId) 
{ strip[stackptr] = ledId;
  stackptr++;
} //void pushToStrip(int ledId) 


void resetAndBlack() 
{ resetStrip();
  for(int i = 0; i<(ARRAYLEN-LEDOFFSET); i++) 
    leds[i] = CRGB::Black;
} //void resetAndBlack() 


void resetStrip() 
{ stackptr = 0;
  for(int i = 0; i<(ARRAYLEN-LEDOFFSET); i++) 
    strip[i] = 0;
} //void resetStrip() 


void displayStripRandomColor() 
{ if( stackptr<(ARRAYLEN-LEDOFFSET) )
    for(int i = 0; i<stackptr; i++) 
      leds[strip[i]] = CHSV(random(0, 255), 255, 255);
  FastLED.show();
} // void displayStripRandomColor() 


void displayStrip() 
{ displayStrip(defaultColor);
} //void displayStrip() 


void displayStrip(CRGB colorCode) 
{ if( stackptr<(ARRAYLEN-LEDOFFSET) )
    for(int i = 0; i<stackptr; i++) 
      leds[strip[i]] = colorCode;
  FastLED.show();
} //void displayStrip(CRGB colorCode) 


void timeToStrip(uint8_t hours,uint8_t minutes)
{ pushES_IST();
  //show minutes
  if(minutes >= 5 && minutes < 10) 
  { pushFUENF1();
    pushNACH();
  } 
  else if(minutes >= 10 && minutes < 15) 
  { pushZEHN1();
    pushNACH();
  } 
  else if(minutes >= 15 && minutes < 20) 
  { pushVIERTEL();
    pushNACH();
  } 
  else if(minutes >= 20 && minutes < 25) 
  { if(selectedLanguageMode == RHEIN_RUHR_MODE) 
    { pushZWANZIG();
      pushNACH();
    } 
    else if(selectedLanguageMode == WESSI_MODE) 
    { pushZEHN1();
      pushVOR();
      pushHALB();
    }
  } 
  else if(minutes >= 25 && minutes < 30) 
  { pushFUENF1();
    pushVOR();
    pushHALB();
  } 
  else if(minutes >= 30 && minutes < 35) 
  { pushHALB();
  } 
  else if(minutes >= 35 && minutes < 40) 
  { pushFUENF1();
    pushNACH();
    pushHALB();
  } 
  else if(minutes >= 40 && minutes < 45) 
  { if(selectedLanguageMode == RHEIN_RUHR_MODE) 
    { pushZWANZIG();
      pushVOR();
    } 
    else if(selectedLanguageMode == WESSI_MODE) 
    { pushZEHN1();
      pushNACH();
      pushHALB();
    }
  } 
  else if(minutes >= 45 && minutes < 50) 
  { pushVIERTEL();
    pushVOR();
  } 
  else if(minutes >= 50 && minutes < 55) 
  { pushZEHN1();
    pushVOR();
  } 
  else if(minutes >= 55 && minutes < 60) 
  { pushFUENF1();
    pushVOR();
  }
	
  int singleMinutes = minutes % 5;
  switch(singleMinutes) 
  { case 1:
      pushONE();
      break;
    case 2:
      pushONE();
      pushTWO();
      break;
    case 3:
      pushONE();
      pushTWO();
      pushTHREE();
      break;
    case 4:
      pushONE();
      pushTWO();
      pushTHREE();
      pushFOUR();
      break;
  } //switch(singleMinutes) 

  if(hours >= 12) 
    hours -= 12;

  if(selectedLanguageMode == RHEIN_RUHR_MODE) 
  { if(minutes >= 25) 
      hours++;
  } 
  else if(selectedLanguageMode == WESSI_MODE) 
  { if(minutes >= 20) 
      hours++;
  }

  if(hours == 12) 
    hours = 0;

  //show hours
  switch(hours) 
  { case 0:
      pushZWOELF();
      break;
    case 1:
      if(minutes > 4) 
        pushEINS(true);
      else 
        pushEINS(false);
      break;
    case 2:
      pushZWEI();
      break;
    case 3:
      pushDREI();
      break;
    case 4:
      pushVIER();
      break;
    case 5:
      pushFUENF2();
      break;
    case 6:
      pushSECHS();
      break;
    case 7:
      pushSIEBEN();
      break;
    case 8:
      pushACHT();
      break;
    case 9:
      pushNEUN();
      break;
    case 10:
      pushZEHN();
      break;
    case 11:
      pushELF();
      break;
  } //switch(hours) 
	
  //show uhr
  if(minutes < 5) 
    pushUHR();
} //void timeToStrip(uint8_t hours,uint8_t minutes)


//---------------------
//PUSH WORD HELPER
//---------------------
void pushES_IST()  
{ pushToStrip(L9);
  pushToStrip(L10);
  pushToStrip(L30);
  pushToStrip(L49);
  pushToStrip(L50);
}

void pushFUENF1() 
{ pushToStrip(L70);
  pushToStrip(L89);
  pushToStrip(L90);
  pushToStrip(L109);
}

void pushFUENF2() 
{ pushToStrip(L74);
  pushToStrip(L85);
  pushToStrip(L94);
  pushToStrip(L105);
}

void pushNACH() 
{ pushToStrip(L73);
  pushToStrip(L86);
  pushToStrip(L93);
  pushToStrip(L106);
}

void pushZEHN1() 
{ pushToStrip(L8);
  pushToStrip(L11);
  pushToStrip(L28);
  pushToStrip(L31);
}

void pushVIERTEL() 
{ pushToStrip(L47);
  pushToStrip(L52);
  pushToStrip(L67);
  pushToStrip(L72);
  pushToStrip(L87);
  pushToStrip(L92);
  pushToStrip(L107);
}

void pushVOR() 
{ pushToStrip(L6);
  pushToStrip(L13);
  pushToStrip(L26);
}

void pushHALB() 
{ pushToStrip(L5);
  pushToStrip(L14);
  pushToStrip(L25);
  pushToStrip(L34);
}

void pushONE() 
{ pushToStrip(SHOWONE);
}

void pushTWO() 
{ pushToStrip(SHOWTWO);
}

void pushTHREE() 
{ pushToStrip(SHOWTHREE);
}

void pushFOUR() 
{ pushToStrip(SHOWFOUR);
}

void pushZWANZIG() 
{ pushToStrip(L48);
  pushToStrip(L51);
  pushToStrip(L68);
  pushToStrip(L71);
  pushToStrip(L88);
  pushToStrip(L91);
  pushToStrip(L108);
}

void pushZWOELF() 
{ pushToStrip(L61);
  pushToStrip(L78);
  pushToStrip(L81);
  pushToStrip(L98);
  pushToStrip(L101);
}

void pushEINS(bool s) 
{ pushToStrip(L4);
  pushToStrip(L15);
  pushToStrip(L24);
  if(s)
    pushToStrip(L35);
}

void pushZWEI() 
{ pushToStrip(L75);
  pushToStrip(L84);
  pushToStrip(L95);
  pushToStrip(L104);
}

void pushDREI() 
{ pushToStrip(L3);
  pushToStrip(L16);
  pushToStrip(L23);
  pushToStrip(L36);
}

void pushVIER() 
{ pushToStrip(L76);
  pushToStrip(L83);
  pushToStrip(L96);
  pushToStrip(L103);
}

void pushSECHS() 
{ pushToStrip(L2);
  pushToStrip(L17);
  pushToStrip(L22);
  pushToStrip(L37);
  pushToStrip(L42);
}

void pushSIEBEN() 
{ pushToStrip(L1);
  pushToStrip(L18);
  pushToStrip(L21);
  pushToStrip(L38);
  pushToStrip(L41);
  pushToStrip(L58);
}

void pushACHT() 
{ pushToStrip(L77);
  pushToStrip(L82);
  pushToStrip(L97);
  pushToStrip(L102);
}

void pushNEUN() 
{ pushToStrip(L39);
  pushToStrip(L40);
  pushToStrip(L59);
  pushToStrip(L60);
}

void pushZEHN() 
{ pushToStrip(L0);
  pushToStrip(L19);
  pushToStrip(L20);
  pushToStrip(L39);
}

void pushELF() 
{ pushToStrip(L54);
  pushToStrip(L65);
  pushToStrip(L74);
}

void pushUHR() 
{ pushToStrip(L80);
  pushToStrip(L99);
  pushToStrip(L100);
}


/*
char *prt_color(uint8_t colorIndex)
{ switch(colorIndex) 
  { case 0:
      return "AliceBlue";
    case 1:
      return "Amethyst";
    case 2:
      return "AntiqueWhite";
    case 3:
      return "Aquamarine";
    case 4:
      return "Azure";
    case 5:
      return "Beige";
    case 6:
      return "Bisque";
    case 7:
      return "BlanchedAlmond";
    case 8:
      return "Blue";
    case 9:
      return "BlueViolet";
    case 10:
      return "Brown";
    case 11:
      return "BurlyWood";
    case 12:
      return "CadetBlue";
    case 13:
      return "Chartreuse";
    case 14:
      return "Chocolate";
    case 15:
      return "Coral";
    case 16:
      return "CornflowerBlue";
    case 17:
      return "Cornsilk";
    case 18:
      return "Crimson";
    case 19:
      return "Cyan";
    case 20:
      return "DarkBlue";
    case 21:
      return "DarkCyan";
    case 22:
      return "DarkGoldenrod";
    case 23:
      return "DarkGray";
    case 24:
      return "DarkGreen";
    case 25:
      return "DarkKhaki";
    case 26:
      return "DarkMagenta";
    case 27:
      return "DarkOliveGreen";
    case 28:
      return "DarkOrange";
    case 29:
      return "DarkOrchid";
    case 30:
      return "DarkRed";
    case 31:
      return "DarkSalmon";
    case 32:
      return "DarkSeaGreen";
    case 33:
      return "DarkGray";
    case 34:
      return "DarkSlateBlue";
    case 35:
      return "DarkSlateGray";
    case 36:
      return "DarkTurquoise";
    case 37:
      return "DarkViolet";
    case 38:
      return "DeepPink";
    case 39:
      return "DeepSkyBlue";
    case 40:
      return "DimGray";
    case 41:
      return "DodgerBlue";
    case 42:
      return "FireBrick";
    case 43:
      return "FloralWhite";
    case 44:
      return "ForestGreen";
    case 45:
      return "Fuchsia";
    case 46:
      return "Gainsboro";
    case 47:
      return "GhostWhite";
    case 48:
      return "Gold";
    case 49:
      return "Goldenrod";
    case 50:
      return "Gray";
    case 51:
      return "Green";
    case 52:
      return "GreenYellow";
    case 53:
      return "Honeydew";
    case 54:
      return "HotPink";
    case 55:
      return "IndianRed";
    case 56:
      return "Indigo";
    case 57:
      return "Ivory";
    case 58:
      return "Khaki";
    case 59:
      return "Lavender";
  }
}  
*/

