#include "pins.h"
#include "peda_dcf77.h"

#define TEILER 146

unsigned char teiler=TEILER;
extern volatile unsigned char count;
extern volatile unsigned char quitt_count;
extern volatile unsigned char lcd_updatetime;
extern volatile unsigned warte_ms;

void irq_set(void)
{ cli();                        //disable global interrupts
  TCCRxA =0;                    //set CTC ?
  TCCRxA |= (1 << COMxA0);      //evtl falsch ?
  OCRxA = (F_CPU / F_INTERRUPTS) - 1;

  TCCRxB = 0;                   //same for TCCR2B
  TCCRxB |= (1 << WGMx2);       //set CTC 
  TCCRxB |= (1 << CSx0);        //clk divider / 1 

  count=0;
  sei();                        //enable global interrupt
}

extern volatile uint8_t _heart;
extern volatile uint8_t _flash;
static uint8_t im_irq=0;

ISR(TIMERx_COMPA_vect)                                                             // Timer1 output compare A interrupt service routine, called every 1/15000 sec
{
#ifdef F_INTERRUPTS
  (void) irmp_ISR();                                                        // call irmp ISR
#endif
if(!im_irq)
{
  if(teiler)
    teiler--;
  else
  { im_irq=1;
sei();  
    teiler=TEILER; 
    count++;

    if(warte_ms)
      warte_ms--;

    if(quitt_count)
      quitt_count--;    
    if(!quitt_count)
      leds[IRQUITT] = CRGB::Black;        
    if(led_test_flags&(1<<LED_ON))
    { if(displayMode != DIY3)
      { if(count==5)
        { leds[SEKUND] = sekundeColor;    
          FastLED.show(); 
 //         LED_MY_DCF77_ON;
        } //if(count==5)
        if(count==25)
        { leds[SEKUND] = CRGB::Black;    
          FastLED.show(); 
 //         LED_MY_DCF77_OFF;
        } //if(count==26)
      } //if(displayMode != DIY3)
      else
      { if(count==5)
        { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[9])); FastLED.show(); } // if(count==5)
        if(count==25)
        { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[3])); FastLED.show(); } // if(count==26)
        if(count==45)
        { FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
          FastLED.show(); 
        } //if(count==26)
      } //if(displayMode == DIY3)
      if(!_heart && !_flash)
      { if(count==5)
        { leds[SEKUND] = sekundeColor; FastLED.show();
        } //if(count==5)
        if(count==19)
        { leds[SEKUND] = CRGB::Black; FastLED.show(); 
        } //if(count==26)
      }
      else
      { leds[SEKUND] = CRGB::Black; FastLED.show(); 
      } //if(count==26)
    } //if(led_test_flags&(1<<LED_ON))  

#ifdef MY_DCF77_IN
    if(dcf77_startzeit)
    { if(!dcf77_OK)
      { if(dcf_off_time)
        { MY_DCF77_POW_OFF;
          dcf_off_time--;
          if(!dcf_off_time)
          { dcf77error_cnt=0;
            MY_DCF77_POW_ON;
          }
        }
        else
        { if(~MY_DCF77_IN_PIN & (1<<MY_DCF77_IN))
          { //LED_KWEISS_ON;
            if(my_cnt_low && !my_cnt_rdy)
            { my_cnt_rdy=1;
              if(my_cnt_rdy)
              { if( (100-my_cnt_low) > 0 )
                { my_dcf77_pulse=100-my_cnt_low; my_dcf77_period=100; merke_my_dcf77_period=my_dcf77_period; }
                else
                { if( (200-my_cnt_low) > 0 && merke_my_dcf77_period==100 )
                  { my_dcf77_pulse=200-my_cnt_low; my_dcf77_period=200; }
                  else
                  { my_dcf77_pulse=0; merke_my_dcf77_period=0; }
                } //!( (100-my_cnt_low) > 0 )  
                scan_dcf77();
              } //if( (100-my_cnt_low) > 0 )
              my_cnt_low=0;
              my_cnt_rdy=0;
            } //if(my_cnt_low && !my_cnt_rdy)
          } //if(~MY_DCF77_PIN & (1<<MY_DCF77_IN))
          else     
          { //LED_KWEISS_OFF;
            if(!my_cnt_rdy)
              my_cnt_low++;
          } //!(~MY_DCF77_PIN & (1<<MY_DCF77_IN))
        } //! if(dcf_off_time)
      } //if(!dcf77_OK)   
    } //if(dcf77_startzeit)
#endif //#ifdef MY_DCF77_IN

    if(count==99)
      count=0;
    im_irq=0;
  } //if !(teiler)
} // if(!im_irq)
} //ISR (TIMER1_COMPA_vect)



