/*
 * peda_dcf77.h
 *
 *              Author: Peter Dannegger
 *                      danni@specs.de
 *
 */
#ifndef PEDA_DCF77_H_
#define PEDA_DCF77_H_

struct PEDA_TIME {
  uint8_t sekund;
  uint8_t minut;
  uint8_t stund;
  uint8_t tach;
  uint8_t wasday;
  uint8_t mona;
  uint8_t jah;
}TIME_T;

//extern struct PEDA_TIME my_time;
extern struct PEDA_TIME newtime;

//#define DCF_MAX_ERROR_TRY 3
//#define DCF_MAX_ERROR_TIME 90

//#define DCF_START_ERROR_TRY 3
//#define DCF_START_ERROR_TIME 90

#define DCF_MAX_ERROR_TRY 10
#define DCF_MAX_ERROR_TIME 600

#define DCF77_sync_HH    3
#define DCF77_sync_MM    5

//#define DCF77_sync_HH    17
//#define DCF77_sync_MM    00

extern uint8_t dcf77error_try;
extern uint32_t dcf77_startzeit;
extern uint8_t dcf77_startzeit_is_set;

extern volatile uint8_t dcf77_OK;
extern volatile uint8_t dcf_off_time;
extern volatile uint8_t dcf77error_cnt;
extern volatile uint8_t my_cnt_rdy;
extern volatile uint8_t my_cnt_low;

extern volatile uint8_t my_dcf77_pulse;
extern volatile uint8_t my_dcf77_period;
extern volatile uint8_t merke_my_dcf77_period;

extern volatile uint8_t dcf77error;
extern volatile uint8_t synchronize;				// successful recieved
extern volatile uint8_t rtc_is_set;

void scan_dcf77( void );
void dcf_auswertung(void);

#endif /* PEDA_DCF77_H_ */






